--Table dumper function to stdio
function tdump(t)
    local function dmp(t, l, k)
    	      if type(t) == "table" then
	      	 print(string.format("%s%s:", string.rep(" ", l*2), tostring(k)))
		 for k, v in pairs(t) do
		     dmp(v, l+1, k)
		 end
	      else
		 print(string.format("%s%s:%s", string.rep(" ", l*2), tostring(k), tostring(t)))
	      end
    end
    dmp(t, 1, "root")
end

function tdump_file(t,path,output_method)
	printtoscreen = 0
	printtofile = 0
	if output_method == 1 or output_method == 3 then printtoscreen = 1 end
	if output_method == 2 or output_method == 3 then printtofile = 1 end
	local function printit(path,line,toscreen,tofile)
		line = line:gsub("<([0-9])>","<row name=\"%1\">") --fix numbered tags
		line = line:gsub("</([0-9])>","</row>") --fix numbered tags
		if toscreen == 1 then print(line) end
		if tofile == 1 then file.write(path, line) end
	end
	local function dmp(t, l, k)
		if type(t) == "table" then
			for k, v in pairs(t) do
                     if tostring(k) ~= "table" then
				printit(path, "\n" .. string.rep(" ", l*2) .. "<" .. tostring(k) .. ">", printtoscreen, printtofile)
				dmp(v, l+1, k)
				if type(v) == "table" then
					printit(path, "\n" .. string.rep(" ", l*2) .. "</" .. tostring(k) .. ">", printtoscreen, printtofile)
				else
					printit(path, "</" .. tostring(k) .. ">", printtoscreen, printtofile)
				end
                     else
                        dmp(v, l, k)
                     end
			end
		else
			content = tostring(t)
			content = content:gsub("<(.*)>","&lt;%1&gt;") --replace restricted characters with entities
			printit(path, content, printtoscreen, printtofile)
		end
	end
	dmp(t, 1, "root")
end

--Get table length
function tablelength(T)
   local count = 0
   for _ in pairs(T) do count = count + 1 end
   return count
end

